// ************************************************************
//
//
//  Progama de Testes para clculo de interseo entre 
//	tringulos
//
//
// ************************************************************
#include <stdio.h>
 
#define X 0
#define Y 1
#define Z 2


int HaInterseccao(float V0[3],float V1[3],float V2[3],
                  float U0[3],float U1[3],float U2[3]);


// ************************************************************
// TestaIntersecTri 
//     esta funo recebe como parmetros dois tringulos e  
//	determina se este se cruzam ou no.
//	Retorno:
//		0: no h interseco entre os tringulos
//		1: h interseco entre os tringulos
//
// ************************************************************
int TestaIntersecTri (float Triangulo_1[3][3], float Triangulo_2[3][3])
{
	return HaInterseccao( Triangulo_1[0],  Triangulo_1[1],  Triangulo_1[2],
						  Triangulo_2[0],  Triangulo_2[1],  Triangulo_2[2]);
		
}

// Triangulo 1
float Tri1[3][3] =  {	10,   0,  10,	// Vrtice 0
						20,  20,  10,	// Vrtice 1
						30,   0,  10 };	// Vrtice 2

// Triangulo 2
float Tri2[3][3] =  {	20,   0,   0,	// Vrtice 0
						20,  20,  10,	// Vrtice 1
						20,   0,  20 }; // Vrtice 2

// ************************************************************
//
//
//
// ************************************************************
void ImprimeTri(float Tri[3][3])
{
	for(int i=0;i<3;i++)
	{
		printf("(%6.2f, %6.2f, %6.2f)\n", Tri[i][X], Tri[i][Y], Tri[i][Z]);
	}
}
// ************************************************************
//
//
//
// ************************************************************
void main()
{

	printf("Triangulo 1:\n");
	ImprimeTri(Tri1);
	printf("Triangulo 2:\n");
	ImprimeTri(Tri2);

	if (TestaIntersecTri(Tri1, Tri2))
		printf("H intersecco\n");
	else printf("No h intersecco\n");

	printf("\n");
	
		
	// efetua uma translao no polgono
	Tri1[0][X] += 11;
	Tri1[1][X] += 11;
	Tri1[2][X] += 11;

	printf("Triangulo 1:\n");
	ImprimeTri(Tri1);
	printf("Triangulo 2:\n");
	ImprimeTri(Tri2);

	if (TestaIntersecTri(Tri1, Tri2))
		printf("H intersecco\n");
	else printf("No h intersecco\n");
	 
}